#line 1 "C:/_MikroC/_MesProjets_MikroC/_16Fxx_MASTER_SLAVE_I2C_MikroE/PIC16F1847_I2CSlave_Protocol/PIC16F_I2C_SlaveFunctions_170602.c"
#line 39 "C:/_MikroC/_MesProjets_MikroC/_16Fxx_MASTER_SLAVE_I2C_MikroE/PIC16F1847_I2CSlave_Protocol/PIC16F_I2C_SlaveFunctions_170602.c"
extern char cI2CAddress;
extern char cI2CData;
extern unsigned char ucI2CRegisters[ 32 ];
extern unsigned char ucI2CRegistersStatus[ 32 ];
extern char cI2CCurrentRegisterNumber;
extern char cI2CTotalMsgCount;
extern char cI2CCurrentMsgCount;
extern char ucI2CCurrentStatus;
extern char cI2CR_W_Operation;
#line 53 "C:/_MikroC/_MesProjets_MikroC/_16Fxx_MASTER_SLAVE_I2C_MikroE/PIC16F1847_I2CSlave_Protocol/PIC16F_I2C_SlaveFunctions_170602.c"
extern const unsigned char _I2C_WRITE = 0;
extern const unsigned char _I2C_READ = 1;
extern const unsigned char _I2C_STATUS_IDLE = 0;
extern const unsigned char _I2C_STATUS_STARTED = 1;
extern const unsigned char _I2C_STATUS_INPROGRESS = 2;
extern const unsigned char _I2C_STATUS_ERROR = 3;
extern const unsigned char _I2C_STATUS_END = 4;
extern const unsigned char _I2C_ADDRESS = 0;
extern const unsigned char _I2C_DATA = 1;









unsigned char PrepareResponseData(unsigned char input)
{
 unsigned char result = 0;
 char receivedMessageCount;
 unsigned char tempVariable;
 receivedMessageCount = input >>  7 ;
 if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber< 32 )
 {
 tempVariable = ucI2CRegisters[cI2CCurrentRegisterNumber];
 tempVariable = tempVariable>>(receivedMessageCount*4);
 tempVariable = tempVariable& 15 ;
 tempVariable = tempVariable | (receivedMessageCount<< 7 );
 result = tempVariable;
 }
 return result;
}










char ParseI2CHeader(unsigned char input)
{
 char result = -1;
 if (input &  64 )
 {
 cI2CCurrentRegisterNumber = input& 31 ;
 cI2CR_W_Operation = input& 32 ;
 if (input& 32 )
 {
 cI2CData = PrepareResponseData(input);
 result = 1;
 }
 else
 {
 if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber< 32 )
 {
 ucI2CCurrentStatus = _I2C_STATUS_STARTED;
 ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_STARTED;
 ucI2CRegisters[cI2CCurrentRegisterNumber] = 0;
 cI2CTotalMsgCount = input>> 7 ;
 result = 1;
 }
 }
 }
 return result;
}









char ParseI2CData(unsigned char input)
{
 char result = -1;
 unsigned char mask;
 char receivedMessageCount = -1;
 if (input &  64 )
 {
 ucI2CCurrentStatus = _I2C_STATUS_ERROR;
 }
 else
 {
 if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber< 32 )
 {
 mask = input &  15 ;
 receivedMessageCount = input >>  7 ;
 cI2CCurrentMsgCount+=1;
 if (receivedMessageCount!=cI2CCurrentMsgCount || cI2CCurrentMsgCount > cI2CTotalMsgCount)
 {
 ucI2CCurrentStatus = _I2C_STATUS_ERROR;
 ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_ERROR;
 ucI2CRegisters[cI2CCurrentRegisterNumber] = 0;
 cI2CCurrentRegisterNumber = -1;
 cI2CTotalMsgCount = -1;
 cI2CCurrentMsgCount = -1;
 }
 else
 {
 mask = mask<<(4*cI2CCurrentMsgCount);
 ucI2CRegisters[cI2CCurrentRegisterNumber] = ucI2CRegisters[cI2CCurrentRegisterNumber] | mask;
 if (cI2CCurrentMsgCount < cI2CTotalMsgCount)
 {
 ucI2CCurrentStatus = _I2C_STATUS_INPROGRESS;
 ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_INPROGRESS;
 result = 1;
 }
 else if (cI2CCurrentMsgCount == cI2CTotalMsgCount)
 {
 ucI2CCurrentStatus = _I2C_STATUS_END;
 ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_END;
 cI2CCurrentRegisterNumber = -1;
 cI2CTotalMsgCount = -1;
 cI2CCurrentMsgCount = -1;
 result = 1;
 }
 }
 }
 }
 return result;
}







void ParseI2CInput(unsigned char input)
{
 if (ucI2CCurrentStatus == _I2C_STATUS_IDLE || ucI2CCurrentStatus == _I2C_STATUS_ERROR || ucI2CCurrentStatus == _I2C_STATUS_END)
 {
 ParseI2CHeader(input);
 }
 else if (ucI2CCurrentStatus == _I2C_STATUS_STARTED || ucI2CCurrentStatus == _I2C_STATUS_INPROGRESS)
 {
 if ((cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber< 32 )
 &&(ucI2CRegistersStatus[cI2CCurrentRegisterNumber] == _I2C_STATUS_STARTED || ucI2CRegistersStatus[cI2CCurrentRegisterNumber] == _I2C_STATUS_INPROGRESS))
 {
 ParseI2CData(input);
 }
 else
 {
 ucI2CCurrentStatus = _I2C_STATUS_ERROR;
 }
 }
 if (ucI2CCurrentStatus == _I2C_STATUS_END)
 {
 ucI2CCurrentStatus = _I2C_STATUS_IDLE;
 }
}







void ManageI2C1Bus()
{
 if (SSP1STAT.R_NOT_W == _I2C_WRITE)
 {


 if (SSP1STAT.D_NOT_A == _I2C_ADDRESS)
 {


 cI2CAddress = SSP1BUF;
 SSP1STAT.BF = 0;
 }
 else
 {


 cI2CData = SSP1BUF;

 ParseI2CInput(cI2CData);
 }
 }
 else
 {

 if (SSP1STAT.D_NOT_A == _I2C_ADDRESS)
 {


 SSPBUF = cI2CData;
 }
 else
 {


 SSP1BUF = cI2CAddress;
 }
 }
 SSPCON.CKP = 1;
 PIR1.SSP1IF = 0;
}
#line 274 "C:/_MikroC/_MesProjets_MikroC/_16Fxx_MASTER_SLAVE_I2C_MikroE/PIC16F1847_I2CSlave_Protocol/PIC16F_I2C_SlaveFunctions_170602.c"
void Init_I2C1_Slave(void)
{
 char counter;
 for (counter = 0; counter< 32 ; counter++)
 {
 ucI2CRegisters[counter] = 0;
 }
 cI2CCurrentRegisterNumber = -1;
 cI2CTotalMsgCount = -1;
 cI2CCurrentMsgCount = -1;
 ucI2CCurrentStatus = _I2C_STATUS_IDLE;


 OSCCON = 0b01110001;
#line 323 "C:/_MikroC/_MesProjets_MikroC/_16Fxx_MASTER_SLAVE_I2C_MikroE/PIC16F1847_I2CSlave_Protocol/PIC16F_I2C_SlaveFunctions_170602.c"
 TRISB.B4=1;
 TRISB.B1=1;
#line 339 "C:/_MikroC/_MesProjets_MikroC/_16Fxx_MASTER_SLAVE_I2C_MikroE/PIC16F1847_I2CSlave_Protocol/PIC16F_I2C_SlaveFunctions_170602.c"
 SSPCON = 0b00100110;
#line 397 "C:/_MikroC/_MesProjets_MikroC/_16Fxx_MASTER_SLAVE_I2C_MikroE/PIC16F1847_I2CSlave_Protocol/PIC16F_I2C_SlaveFunctions_170602.c"
 SSP1CON2 = 0b00110110;
#line 442 "C:/_MikroC/_MesProjets_MikroC/_16Fxx_MASTER_SLAVE_I2C_MikroE/PIC16F1847_I2CSlave_Protocol/PIC16F_I2C_SlaveFunctions_170602.c"
 SSP1STAT = 0b10000000;

 cI2CAddress =  0x40 ;


 SSP1ADD = cI2CAddress;



 PIE1 = PIE1 | 0b00001000;
#line 477 "C:/_MikroC/_MesProjets_MikroC/_16Fxx_MASTER_SLAVE_I2C_MikroE/PIC16F1847_I2CSlave_Protocol/PIC16F_I2C_SlaveFunctions_170602.c"
 INTCON = INTCON | 0b11000000;
#line 503 "C:/_MikroC/_MesProjets_MikroC/_16Fxx_MASTER_SLAVE_I2C_MikroE/PIC16F1847_I2CSlave_Protocol/PIC16F_I2C_SlaveFunctions_170602.c"
}
